<%@page import="java.util.Map.Entry"%>
<%@page import="com.jalios.jcms.analytics.agent.*"%><%
%><%@page import="com.jalios.jcms.analytics.*"%><%
%><%@page import="com.jalios.jcms.analytics.metric.*"%><%
%><%@page import="com.jalios.jcms.analytics.ui.*"%><%
%><%@page import="com.jalios.jcmsplugin.hourlyReport.*"%><%
%><%@ include file='/jcore/doInitPage.jsp' %><%

%><div class="chart-result" style="overflow:hidden;"><%

ReportHandler formHandler = (ReportHandler) request.getAttribute("ui.analytics.current-report-handler");
Date endDate = formHandler.getAvailableEndDate();
endDate = DateUtil.getDayEndDate(endDate, userLocale);
Date beginDate = formHandler.getAvailableBeginDate();
String wkId = formHandler.getAnalyticsWS();
Workspace wk = channel.getData(Workspace.class, wkId);
Set<AbstractReportMetric> metricSet = AbstractStatisticAgent.getMetricObjectSet(wk,beginDate,endDate, null, HourlyReportMetric.class);

if(Util.isEmpty(metricSet)){
  %><%=glp("ui.analytics.report.no-result")%><%
}
else{
  Map<Date, Double> averageDataMap = new HashMap<Date, Double>();
  Map<Date, Double> maxDataMap = new HashMap<Date, Double>();
  Map<Date, Double> minDataMap = new HashMap<Date, Double>();
 
  //fill with empty report in period if report are missing
  AnalyticsManager.completeMetricObjectSet(metricSet, beginDate, endDate, userLocale, HourlyReportMetric.class);
  metricSet = AnalyticsManager.aggregateAllUrid(metricSet,HourlyReportMetric.class);
  
  long value = 0;
  Double currentAverageValue;
  Double currentMaxValue ;
  Double currentMinValue;
    
  Iterator<AbstractReportMetric> metricIt = metricSet.iterator();
  int metricIndex = 1;
  while(metricIt.hasNext()){
    	HourlyReportMetric metric = (HourlyReportMetric) metricIt.next();
  		
  		for(int hour= 0;hour < 24 ; hour ++){
  			value = metric.getHourValue(hour);
  			Date workDate = new Date(3600000 * hour);
  			
  			//average value
  			currentAverageValue = averageDataMap.get(workDate);
  			if(currentAverageValue == null){
  			  currentAverageValue =  Double.valueOf(0);
  			}
  			currentAverageValue = ((currentAverageValue * metricIndex) + value)/(metricIndex +1);
  			averageDataMap.put(workDate, currentAverageValue);
  			
  			//max value
  			currentMaxValue = maxDataMap.get(workDate);
  			if(currentMaxValue == null){
  			  currentMaxValue =  Double.valueOf(0);
  			}
  			if(value > currentMaxValue){
  			  maxDataMap.put(workDate,Double.valueOf(value));
    		}
  			
  			//min value
  			currentMinValue = maxDataMap.get(workDate);
  			if(currentMinValue == null){
  			  currentMinValue = Double.MAX_VALUE;
  			}
			if(value < currentMinValue){
			  minDataMap.put(workDate, Double.valueOf(value));
  			}
			
  		}
  		metricIndex ++;
 }
  %>
 <div class="row-fluid">
  <% String suffix = "_hourlyReport"; %>
  <div class="span6 report-element hourlyReport-chart">
   <h3><%=glp("jcmsplugin.hourlyReport.section") %></h3>
   <span class="help-block"><%=glp("jcmsplugin.hourlyReport.section.help") %></span>
   <jalios:flotChart name='<%=suffix%>' externalLegend="true" selectableLegend="true" width="500px">
    <jalios:flotChartData label='<%=glp("jcmsplugin.hourlyReport.averageCount") %>' valuesMap='<%=averageDataMap %>'/>
    <jalios:flotChartData label='<%=glp("jcmsplugin.hourlyReport.maxCount") %>' valuesMap='<%=maxDataMap %>'/>
    <jalios:flotChartData label='<%=glp("jcmsplugin.hourlyReport.minCount") %>' valuesMap='<%=minDataMap %>'/>
   </jalios:flotChart>
  </div>
 </div>
<%}%>
</div>